unit secd_cod;
interface

const
 s=0; e=1; c=2; w1=4; a=5; b=6;

 Debug:boolean=false;

var
 LoopCnt:longint;

procedure secd_loop;
procedure ShowSECD;

{ 
 SECD commands:

  1 LD x y       s  e c           --> ((GetNth(GetNth(e,x),y) s) e c  
  2 LDC          s  e (x c)       --> (x s)   e      c 
  3 LDF          s  e (f c)       --> (x.e s) e      c 
  4 
  5 RTN          (x e' c' s) e c  --> (x s)   e'     c'
  6 DUM          s           e c  --> s      (nil e) c 

  
  7 DEC     (x s) e c  --> (x-1 s)      e c    
  8 INT     (x s) e c  --> (int?(x) s)  e c
  9 INC     (x s) e c  --> (x+1 s)      e c 
 10 CAR     (x s) e c  --> (car(x) s)   e c
 11 CDR     (x s) e c  --> (cdr(x) s)   e c
 12 ATOM    (x s) e c  --> (atom?(x) s) e c
 13 CONS    (x y s) e c  --> (cons(x,y) s) e c  
 14 EQ      (x y s) e c  --> (eq(x,y)   s) e c
 15    
 16 
 17    
 18
 19 
 20 
 21 STOP
 22 ADD     (x y s) e c  --> (x+y s)       e c 
 23 SUB     (x y s) e c  --> (x-y s)       e c 
 24 MUL     (x y s) e c  --> (x*y s)       e c 
 25 DIV     (x y s) e c  --> ((x div y) s) e c 
 26 REM     (x y s) e c  --> ((x mod y) s) e c 
 27 LEQ     (x y s) e c  --> ((x <= y) s)  e c  --> for integers 
 28 LEXLEQ  (x y s) e c  --> ((x <= y) s)  e c  --> for atom names
 29
 20
 31

 ---------------------------- APP / TR_APP codes: ------------------------------

 32 LET n        s         e (c' c)    --> (e c Drop(s,n))       (s e)       c' 
 33 TRLET n      s         e c         --> Drop(s,n)             (s e)       c  
 34 LETREC n     s         e (c' c)    --> ((cdr e) c Drop(s,n)) Setcar(e,s) c' 
 35 TRLETR n     s         e c         --> Drop(s,n)             Setcar(e,s) c  
 36 APP n        (c'.e' s) e c         --> (e c Drop(s,n))       (s e')      c' 
 37 TR_APP n     (c'.e' s) e c         --> Drop(s,n)             (s e')      c' 
 38 SEL          (x s)     e (c1 c2 c) --> (e c s)               e           cx 
 39 TR_SEL       (x s)     e (c1 c2)   --> s                     e           cx 

}

implementation
uses secd_mem, secd_str;

const
 ChCnt:byte=0;

procedure ShowSECD;
 const CMax=100;
 procedure ShowCache;
  begin
   case ChCnt of
    0:begin
       write(fout,'S=  '); 
      end;
    1:begin
       write(fout,'Sa= '); ShowReg(a,CMax,false); writeln(fout);
       write(fout,'St= '); 
      end;
    2:begin
       write(fout,'Sa= '); ShowReg(a,CMax,false); writeln(fout);
       write(fout,'Sb= '); ShowReg(b,CMax,false); writeln(fout);
       write(fout,'St= '); 
      end;
   end; 
   ShowReg(s,CMax,false); writeln(fout);
  end;
 begin
  writeln(fout,'SECD: Loops=',LoopCnt,'  Cons=',ConsCnt); 
  ShowCache;
  write(fout,'E=  '); ShowReg(e,CMax,false); writeln(fout);
  write(fout,'C=  '); ShowReg(c,CMax,false); writeln(fout);
  {readln;} 
 end;

procedure secd_loop;
 var
  cmd:word;
  par:longint;
  OK:boolean;
 procedure Just(n:byte);
  begin if ChCnt<>n then begin
   case ChCnt of
    0:if n=1 
       then Pop(s,a)
       else begin Pop(s,a); Pop(s,b) end;
    1:if n=0 
       then Push(a,s) else Pop(s,b); 
    2:if n=1 
       then Push(b,s)
       else begin Push(b,s); Push(a,s) end;
   end;
   ChCnt:=n;
  end end;
  
 procedure Test;
  var s1:string;  
  begin
   if ChCnt=0 then Just(1);
   if Regs[a].t<>atom then Error('If exp is not boolean (T/F)');
   s1:=GetStr(Regs[a].v);
   OK:=(s1='T') or (s1='t');
   dec(ChCnt);
   if ChCnt=1 then MoveReg(b,a);
  end; 
 procedure UniCmd;
  begin
   if ChCnt=0 then Just(1);
   if cmd in [7,9] then if Regs[a].t<>int 
    then Error('The argument must be int'); 
   case cmd of
     7:dec(Regs[a].v);
     8:if  Regs[a].t=int  then NewAtom('T',a) else NewAtom('F',a);
     9:inc(Regs[a].v);
    10:CarSelf(a);
    11:CdrSelf(a);
    12:if  Regs[a].t=atom then NewAtom('T',a) else NewAtom('F',a);
   end;     
  end;
 procedure BinCmd;
  begin
   Just(2);
   if cmd in [22..27] then begin
    if Regs[a].t<>int then Error('Second argument must be int'); 
    if Regs[b].t<>int then Error( 'Furst argument must be int'); 
   end;
   if cmd in [28] then begin
    if Regs[a].t<>atom then Error('Second argument must be atom'); 
    if Regs[b].t<>atom then Error( 'Furst argument must be atom'); 
   end;
   case cmd of
    13:PushR(b,a);
    14:if (Regs[b].t=Regs[a].t) and (Regs[b].v=Regs[a].v) 
        then NewAtom('T',a) else NewAtom('F',a);
    22:Regs[a].v:=Regs[b].v+Regs[a].v;
    23:Regs[a].v:=Regs[b].v-Regs[a].v;
    24:Regs[a].v:=Regs[b].v*Regs[a].v;
    25:Regs[a].v:=Regs[b].v div Regs[a].v;
    26:Regs[a].v:=Regs[b].v mod Regs[a].v;
    27:if Regs[b].v <= Regs[a].v
        then NewAtom('T',a) else NewAtom('F',a);
    28:if GetStr(Regs[b].v) <= GetStr(Regs[a].v)
        then NewAtom('T',a) else NewAtom('F',a);
   end;     
   ChCnt:=1;
  end;
 procedure Rtn;
  begin
   Just(2);
   MoveReg(b,e);
   Pop(s,c);
   ChCnt:=1;
  end;
 procedure LDx;
  begin
   if ChCnt=2 then Just(1);
   inc(ChCnt);
   if ChCnt=2 then MoveReg(a,b);
   case cmd of
    1:begin
       GetNth(e,w1,par shr 8);
       GetNth(w1,a,par and $ff);
      end;
    2:Pop(c,a);
    3:begin Pop(c,a); PushR(e,a) end;
   end;
  end; 
 begin
  repeat
   if Debug then ShowSECD; 
   inc(LoopCnt);
   Pop(c,w1);
   if Regs[w1].t<>int 
    then Error('Command not found at the top of C') 
    else begin
     cmd:=Regs[w1].v shr 24;
     par:=Regs[w1].v and $ffffff;
     case cmd of
       1..3:LDx;
       4:;
       5:Rtn;
       6:begin SetAtom(w1,null,-1); Push(w1,e) end;
       7..12:UniCmd;
      13..14:BinCmd;
      15..20:;
      21:push(w1,c);  
      22..28:BinCmd;
      32:begin { LET:     s e (c' c)  --> (e c Drop(s,n)) (s e) c'  }
          Just(0);
          Cdr(c,b);
          MoveReg(e,a); 
          Push(s,e);
          Drop(s,par);
          CarSelf(c);
          ChCnt:=2;
         end;
      33:begin { TRLET:   s e c       --> Drop(s,n) (s e) c       }
          Just(0); 
          Push(s,e); 
          Drop(s,par);
         end;
      34:begin { LETREC:  s e (c' c)  --> ((cdr e) c Drop(s,n)) Setcar(e,s) c' }
          Just(0); 
          Cdr(c,b);
          Cdr(e,a); 
          SetCar(e,s);
          Drop(s,par);
          CarSelf(c);
          ChCnt:=2;
         end;
      35:begin { TRLETR:  s e c       --> Drop(s,n) Setcar(e,s) c  } 
          Just(0); 
          SetCar(e,s); 
          Drop(s,par);
         end;
      36:begin { APP:     (c'.e' s) e c --> (e c Drop(s,n)) (s e') c' }
          Just(1);
          MoveReg(c,b);
          MoveReg(a,c);
          MoveReg(e,a);
          Cdr(c,e); 
          Push(s,e);
          CarSelf(c);
          Drop(s,par);
          ChCnt:=2;
         end; 
      37:begin { TRAPP:   (c'.e' s) e c --> Drop(s,n) (s e')    c' }
          Just(1);
          MoveReg(a,e); 
          Pop(e,c);
          Push(s,e); 
          Drop(s,par);
          ChCnt:=0;
         end; 
      38:begin { SEL:     (x s) e (c1 c2 c) --> (e c s) e cx }
          Test;
          Just(0);
          if OK
           then begin MoveReg(c,b); Pop(b,c); CdrSelf(b) end 
           else begin CdrSelf(c);   Cdr(c,b); CarSelf(c) end;
          MoveReg(e,a);
          ChCnt:=2;
         end;
      39:begin { TRSEL:   (x s) e (c1 c2)   --> s e cx }
          Test;
          if OK then CarSelf(c) else CdrSelf(c);
         end;
     end;
    end;
  until cmd=21;
  Just(0);
 end;

begin
 LoopCnt:=0;
end.


