(let

(letrec 

  (fork 
    (accept (listen 5 5813)) 
    (shell_0 (fopen 0 nil) (fopen 1 nil)) 
  )

  (accept lambda(listener)
    (do socket (recv listener)
        (fork 
          (accept listener) 
          (shell_0 (car socket) (cdr socket))
  )))

  (shell_0 lambda(input output)
    (letrec 
      (shell input output syspipe err_handler)
      (err_handler lambda(nSEC)
        (seq (send nSEC syspipe) (fail 0)))
      (syspipe cons nil nil)  
  ))

)

(shell lambda (input output syspipe err_handler)
(inLib compiler

 (letrec 

  (sh_loop)

  (assoc lambda(n l)
    (if (null l) n
        (if (eq n (car (car l))) 
            (cdr (car l))
            (assoc n (cdr l)))))

  (show_err lambda(l)
    (if (null l) nil
    (if (atom l) (print l nil)
    (seq (send  (quote SEC_code:) output)
    (seq (sendc 32 output)
    (seq (print  (car (cdr l)) nil)
    (seq (send  (quote Runtime_error:) output)
    (seq (sendc 32 output)
    (seq (print 
            (assoc (car l) (ReadSFrom (f2name (quote errors) (quote lst))))
            nil)        
         (sendc 10 output)
    )))))))))

  (sh_loop lambda()
    (if (eof input)
        (seq (sysmsg (quote (Closed connection))) 
             (seq (fclose input) 
             (seq (fclose output) (fail 0))))
        (fork
          (seq (show_err (recv syspipe)) (sh_loop))
          (seq (send (sh_step) syspipe) (fail 0)))
  ))

  (sh_step lambda()
    (seq (send (quote SEC>) output)
    (seq (print (eval (read input)) (quote secd)) 
         nil)
  ))

  (self env)

  (comp_lsp lambda (fn)
    (comp_lex fn (car self)))

  (eval lambda(e)
    (do body (force (comp e (cons nil (car self)) nil))
    (seq (print body (quote secd))
    (do closure (cdr self)
       ((cons body closure)) ))))       

  (exec lambda(fn)
    (do body (force (ReadSFrom (f2name fn (quote sec))))
    (do closure (cdr self)
        ((cons body closure)) )))

  (comp_lex lambda (fn scope)
    (seq (send fn output)
    (seq (WriteSTo
           (comp (ReadSFrom (f2name fn (quote lsp))) 
                 (if (null scope) nil (cons nil scope)) nil)
           (quote secd)
           (f2name fn (quote sec)))
    (seq (sendc 10 output)
         (quote OK)))))

  (comp_self lambda()
    (seq (comp_lex (quote miniOS) nil)
         (comp_lex (quote client) nil)))
    
  (comp_kernel lambda()
    (seq (comp_lsp (quote strict))
         (exec (quote strict))))

  (comp_all lambda() (seq (comp_kernel) (comp_self)))

))))
