unit sec_codes;
interface

const
 w1=0; { work register }
 
 userMode:boolean=false;
 ShdMaxCnt=511 { 127 };

var
 LoopCnt :longint;

procedure RTError(n:word; msg:string);
procedure secd_start;
procedure ShowSECD;

{ 

  WARNING: There is some info about the SECK machine
           in file html/secd.html !!!

}

implementation

{$MACRO ON}

uses sec_lists, sec_atoms, sec_drivers;

const
  { registers from 1 to SCMax represent S cache }
  SCMax=12;                 { size of  S cache }
  SCMid=SCMax div 2;        { midle of the cache } 
   s=SCMax+1;   e=SCMax+2;   c=SCMax+3;  { SEC itself   } 
  sk=SCMax+4;  ek=SCMax+5;  ck=SCMax+6;  { kernel state }
  s1=SCMax+7;  e1=SCMax+8;  c1=SCMax+9;  { SEC swap     } 
  u=SCMax+10;               { error code } 
  l=SCMax+11;               { E cache - local vars }

 Debug:boolean=false;
 stopSEC:boolean=false;

 { Cache memory vars: }
 a:byte=0;
 CacheE:boolean=false;

var
 cmd:word;       { current SECK command }
 par:longint;    { current command parameter }
 SwapOK:boolean;
 CPCnt :longint; { current task counter }

procedure secd_loop; forward;

{ ----- Cache for E: ----- }

{$define PackE:=if CacheE then Push(l,e);CacheE:=false}
{$define MakeE:=if CacheE then Push(l,e);CopyReg(s,l);CacheE:=true}

{ ------- Cache for S: ------ }

procedure Just(n:byte);
 var i:byte;
 begin if a<>n then begin
  if a<n then begin
   if a>0 then for i:=a downto 1 do 
    MoveReg(i,i+n-a);
   for i:=n-a downto 1 do Pop(s,i); 
  end else begin
   for i:=1 to a-n do Push(i,s);
   if n>0 then for i:=1 to n do 
    MoveReg(i+a-n,i);
  end;
  a:=n;
 end end;

{$define s_b:=a-1 }
{$define s_c:=a-2 }
{$define IncSP:=if a=SCMax then Just(SCMid); inc(a)}
{$define DecSP:=if a=0 then Drop(s,1) else dec(a)} 
{$define Least1:=if a=0 then begin a:=1; Pop(s,a) end}
{$define Least2:=if a<2 then Just(2)}
{$define Least3:=if a<3 then Just(3)}

{ ----- Debug & show: ----- }

procedure ShowSECD;
 const CMax=80;
 procedure ShowCache;
  begin
   case a of
    1:begin
       write(stderr,'Sa= '); ShowReg(a,CMax,false); writeln(stderr);
      end;
    2:begin
       write(stderr,'Sa= '); ShowReg(  a,CMax,false); writeln(stderr);
       write(stderr,'Sb= '); ShowReg(s_b,CMax,false); writeln(stderr);
      end;
    3..SCMax:begin
       write(stderr,'Sa= '); ShowReg(  a,CMax,false); writeln(stderr);
       write(stderr,'Sb= '); ShowReg(s_b,CMax,false); writeln(stderr);
       write(stderr,'Sc= '); ShowReg(s_c,CMax,false); writeln(stderr);
      end;
   end; 
   if a>3 then writeln(stderr,'... SP=',a); 
   write(stderr,'Sn= '); 
   ShowReg(s,CMax,false); writeln(stderr);
  end;
 begin
  writeln(stderr,'--- SECK registers: ---');
  ShowCache;
  if CacheE then begin
   write(stderr,'L=  '); ShowReg(l,CMax,false); writeln(stderr);
   write(stderr,'Et= '); ShowReg(e,CMax,false); writeln(stderr);
  end else begin
   write(stderr,'E=  '); ShowReg(e,CMax,false); writeln(stderr);
  end; 
  write(stderr,'C=  '); ShowReg(c,CMax,false); writeln(stderr);
  {readln;} 
 end;

procedure DumpStack;
 const w=MaxReg-1;
 function SP:word;
  var n:word; 
  begin
   n:=0; CopyReg(s,w);
   while Regs[w].t=node do begin inc(n); Drop(w,1) end;
   SP:=a+n;
  end;
 begin if (LoopCnt>1000000) and (LoopCnt<1010000) then begin
  if userMode then write(stderr,'u') else  write(stderr,'k');
  write(stderr,' SP=',SP:3,' cache=',a:2,' ');
  if Regs[c].t=null then write(stderr,'#rtn') else begin
   Car(c,w); ShowReg(w,20,false);
  end;
  writeln(stderr);  
 end end;

{ ----- SECK commands: ----- }

procedure TRApp(par:word); 
 begin { TRAPP:   (c'.e' s) e c --> Drop(s,n) (s e')    c' }
  Just(1);
  MoveReg(a,e); Pop(e,c);
  CopyReg(s,l); CacheE:=true;
  Drop(s,par);
  DecSP;
 end; 

procedure Prev(par:word);
 begin
  IncSP;
  CopyReg(par+s1,a);
 end;

procedure SwapRegs;
 begin
  SwapReg(s,s1);
  SwapReg(e,e1);
  SwapReg(c,c1);
 end;

procedure Intr(par:word);
 begin
  Just(0); PackE;
  IncSP;
  SetAtom(a,int,par);
  if userMode then begin
   if par<128 
    then CopyReg(a,u)
    else SetAtom(u,int,cmd);
   CopyReg(s1,sk);
   CopyReg(e1,ek);
   CopyReg(c1,ck);
   SwapRegs;
  end else begin
   CopyReg(sk,s);
   CopyReg(ek,e);
   CopyReg(ck,c);
  end;
  userMode:=false;
  SwapOK:=true;
 end;
 
procedure RTError(n:word; msg:string);
 begin
  writeln(stderr);
  writeln(stderr,msg,' !');
  ShowSECD;
  Flush(stderr);
  
  Intr(n+128);
  secd_loop;
 end;

procedure SetBool(d:byte; b:boolean);
 begin
  if b then SetAtom(d,int,0) else SetAtom(d,int,1);
 end;
 
procedure Kernel1;
 var 
  ok:boolean;
  ws:string;
 begin
  Least1;
  if (cmd in [80..86,88]) and (Regs[a].t<>int)
   then RTError(0,'The argument must be int');
  case cmd of
   80:begin
       ws:=FGetLex(PStream(Regs[a].v),ok);
       if ok then NewAtom(ws,w1);
       SetBool(a,ok); PushR(w1,a);
      end;
   81:begin
       SetAtom(w1,int,ord(FGetChar(PStream(Regs[a].v),ok)));
       SetBool(a,ok); PushR(w1,a);
      end;
   82:begin
       SetBool(a,StreamCont(PStream(Regs[a].v)));
       PushR(w1,a);
      end;
   83:SetBool(a,FEof(PStream(Regs[a].v)));
   84:begin
       FClose(PStream(Regs[a].v));
       SetAtom(a,int,longint(nil));
      end;
   85:Delay(Regs[a].v); 
   86:Intr( Regs[a].v);
   87:SetAtom(a,int,ord(SubTag(a)));
   88:begin
       SetAtom(w1,int,longint(TCPGetConn(PTCPSocket(Regs[a].v),ok)));
       SetBool(a,ok); PushR(w1,a);
      end;
  end; 
 end;

procedure Kernel2;
 var ws:string;
 begin
  Least2;
  if (cmd in [65..67,70..72]) and (Regs[a].t<>int)
   then RTError(1,'The second argument must be int');
  if (cmd in [70..72]) and (Regs[s_b].t<>int)
   then RTError(2,'First argument must be int'); 
  case cmd of
   64:begin
       if Regs[s_b].t<>int then 
        RTError(5,'First argument must be TStreamType: 0-input 1-output'); 
       case Regs[a].t of
        null:ws:='';
        atom:ws:=GetStr(Regs[a].v);
       end;
       SetAtom(s_b,int,longint(FOpen(ws,TStreamType(Regs[s_b].v))));
      end; 
   65:begin
       case Regs[s_b].t of
        null:ws:='nil';
        int:ws:=GetLong(Regs[s_b].v);
        atom:ws:=GetStr(Regs[s_b].v);
        node:RTError(9,'Sending node to stream is impossible');
       end;
       SetBool(s_b,FPutStr(PStream(Regs[a].v),ws));
      end;
   66:begin
       if Regs[s_b].t<>int
        then RTError(10,'SendC allow only integers');
       SetBool(s_b,FPutChar(PStream(Regs[a].v),Chr(Regs[s_b].v)));
      end;
   67:SetSubTag(s_b,TSubTag(Regs[a].v));
   68:SetCar(s_b,a); 
   69:SetCdr(s_b,a);
   70:SetAtom(s_b,int,longint(
       SOpen(PTCPSocket(Regs[a].v),TStreamType(Regs[s_b].v))));
   71:SetAtom(s_b,int,longint(TCPConnect(Regs[a].v,Regs[s_b].v)));
   72:SetAtom(s_b,int,longint(TCPListen( Regs[a].v,Regs[s_b].v)));
  end;     
  DecSP;
 end;

procedure secd_loop;
 procedure Primitive(cmd:word);
  procedure UniCmd;
   begin
    Least1;
    if (cmd in [55..58]) and (Regs[a].t<>int)
     then RTError(0,'The argument must be int');
    case cmd of
      48:CarSelf(a);
      49:Drop(a,1);
      50:SetBool(a,Regs[a].t=int);
      51:SetBool(a,Regs[a].t=atom);
      52:SetBool(a,Regs[a].t=null);
      53:SetBool(a,Regs[a].t=node);
      54:;
      55:begin
          ShowStat;  
          if Regs[a].v<>0 then Halt;
         end; 
      56:inc(Regs[a].v);
      57:dec(Regs[a].v);
      58:NewAtom(chr(Regs[a].v),a);
      59..63:;
    end;     
   end;
  procedure BinCmd;
   begin
    Least2;
    if cmd in [22..27] then begin
     if Regs[  a].t<>int then RTError(1,'Second argument must be int'); 
     if Regs[s_b].t<>int then RTError(2,'First argument must be int'); 
    end;
    if cmd in [28,30] then begin
     if Regs[  a].t<>atom then RTError(3,'Second argument must be atom'); 
     if Regs[s_b].t<>atom then RTError(4,'First argument must be atom'); 
    end;
    case cmd of
     16:Push(a,s_b);
     17:SetBool(s_b,(Regs[s_b].t=Regs[a].t) and (Regs[s_b].v=Regs[a].v)); 
     18..21:;
     22:Regs[s_b].v:=Regs[s_b].v+Regs[a].v;
     23:Regs[s_b].v:=Regs[s_b].v-Regs[a].v;
     24:Regs[s_b].v:=Regs[s_b].v*Regs[a].v;
     25:Regs[s_b].v:=Regs[s_b].v div Regs[a].v;
     26:Regs[s_b].v:=Regs[s_b].v mod Regs[a].v;
     27:SetBool(s_b,Regs[s_b].v <= Regs[a].v);
     28:SetBool(s_b,GetStr(Regs[s_b].v) <= GetStr(Regs[a].v));
     30:NewAtom(GetStr(Regs[s_b].v)+GetStr(Regs[a].v),s_b);
    end;     
    DecSP;
   end;
  begin
   if cmd<64 
    then case cmd of
      16..31:BinCmd;
      48..63:UniCmd;
    end
    else if cmd<128
     then Intr(cmd)
     else TRApp(cmd-128);   
  end;
 procedure CleanX;
  var finish:boolean; 
  begin
   repeat
    if TestRec(a) then begin
      Car(a,w1);
      finish:=Regs[w1].t<>null; 
      if not finish 
       then Drop(a,1)
       else if Regs[w1].t=int then Intr(2);
              { [p.q] --> [p.((s e c) q)] } 
    end else finish:=true;
   until finish;
  end;
 procedure Rec;
  begin
   if TestRec(a) then begin
    PackE; IncSP; IncSP;
    MoveReg(s_c,a);
    MoveReg(e,s_b); 
    MoveReg(c,s_c);
    StartRec(a,e,c,par);
   end else Primitive(par);
  end; 
 procedure TR_Rec;
  begin
   if TestRec(a) 
    then begin CacheE:=false; StartRec(a,e,c,par) end
    else Primitive(par);
  end;
 procedure Rtn;
  var p:word; 
  begin
   Least3;
   if TestRec(s_b) then begin
    CleanX;
    if SwapOK then Exit;
    if TestRec(a) 
     then begin CacheE:=false; StartRec(a,e,c,0) end
     else begin
      p:=ReplaceRec(a,s_b);
      { Specialy for nodes the replaced recipe is returned: }
      if Regs[a].t<>node then MoveReg(a,s_b); 
      DecSP;
      if Regs[w1].t=node then begin
       { activate all processes, waiting for this value }
       IncSP; IncSP;
       SetAtom(s_b,int,p);
       MoveReg(w1,a);
       Intr(3);
      end else if p>0 then begin 
        if p>127 then RTError(6,'#trapp_n into #rtn'); 
        Primitive(p);  
      end;  
     end;
   end else begin
    MoveReg(s_b,e); CacheE:=false;
    MoveReg(s_c,c);
    MoveReg(a,s_c);
    DecSP; DecSP;
   end;
  end;
 procedure LDx;
  var x,y:word;
  begin
   IncSP;
   case cmd of
    1:begin
       x:=par shr 8;
       y:=par and $ff;
       if CacheE then if x=0 
         then GetNth(l,a,y)
         else begin GetNth(e,w1,x-1); GetNth(w1,a,y); end
        else begin GetNth(e,w1,x); GetNth(w1,a,y); end; 
      end;
    2:Pop(c,a);
    3:begin PackE; Pop(c,a); PushR(e,a) end;
    4:begin PackE; Pop(c,a); PushR(e,a); SetSubTag(a,recipe) end; 
   end;
  end; 
 procedure CASE_k;
  var k:longint;
  begin
   Least1;
   if Regs[a].t=int then k:=Regs[a].v else k:=par;
   if (k<0) or (k>par) then k:=par;
   GetNth(c,a,k);
   Drop(c,par+1);
  end;
 procedure CALL; 
  begin
   if Regs[c].t=node then begin { normal CALL }
    Least1;
    SwapReg(a,c);
    IncSP;
    PackE;
    CopyReg(e,a);
   end else begin               { TR CALL }   
    Least1;
    MoveReg(a,c); 
    DecSP;
   end;
  end;
 procedure SpecCmd;
  begin
   case cmd of
     1..4:LDx;
     5:CASE_k; 
     6:begin 
        if CacheE then Push(l,e);
        SetAtom(l,null,-1); CacheE:=true;
       end;
     7:; { stop - Phase0 }
     8:CALL;
     9:;
    10:;
    11:;
    12:;
    13:;
    14:DecSP; { POP }
    15:Primitive(par);   
   end;
  end;
 procedure user0;
  begin
   MoveReg(a,c1);
   PackE;
   SwapRegs;
   SetAtom(u,null,0);
   userMode:=true; a:=0;
  end;
 procedure CallCmd;
  begin
   case cmd of
    32:begin { LET:     s e (c' c)  --> (e c Drop(s,n)) (s e) c'  }
        Just(0); a:=2;
        SwapReg(c,s_b); Pop(s_b,c);
        MakeE;
        CopyReg(e,a); 
        Drop(s,par);
       end;
    33:begin { TRLET:   s e c       --> Drop(s,n) (s e) c       }
        Just(0); 
        MakeE; 
        Drop(s,par);
       end;
    34:begin { LETREC:  s e (c' c)  --> ((cdr e) c Drop(s,n)) Setcar(e,s) c' }
        Just(0); a:=2;
        SwapReg(c,s_b); Pop(s_b,c);
        PackE; Cdr(e,a); 
        SetCar(e,s);
        Drop(s,par);
       end;
    35:begin { TRLETR:  s e c       --> Drop(s,n) Setcar(e,s) c  } 
        Just(0); 
        PackE; SetCar(e,s); 
        Drop(s,par);
       end;
    36:begin { APP:     (c'.e' s) e c --> (e c Drop(s,n)) (s e') c' }
        Just(1); 
        MakeE;
        IncSP;
        MoveReg(s_b,a);
        Pop(a,s_b);
        SwapReg(s_b,c);
        SwapReg(a,e);
        Drop(s,par);
       end; 
    37:TRApp(par); { TRAPP:   (c'.e' s) e c --> Drop(s,n) (s e') c' }
    38:;
    39:;
    40:Rec;
    41:TR_Rec;
    42:;
    43:;
    44:begin 
        Just(3);
        MoveReg(s_b,e1);
        MoveReg(s_c,s1);
        user0;
       end; 
    45:begin 
        CPCnt:=0;
        Just(1);
        Pop(a,s1);
        Pop(a,e1);
        user0;
       end;
    46:Intr(par);
    47:Prev(par);
   end;
  end;
 procedure Phase0;
  begin
   case cmd of
     7:begin
        if userMode then Intr(100) else stopSEC:=true; 
        SwapOK:=true;
       end; 
    40,41:begin { Rec / TR_Rec }
       Least1;
       CleanX;
      end;
   end;
  end;
 procedure Phase1;
  begin
   Drop(c,1); 
   case cmd of
     1..15:SpecCmd;
    16..31:Primitive(cmd);
    32..47:CallCmd;
    48..63:Primitive(cmd);
    64..79:Kernel2;
    80..95:Kernel1;
   end;
  end;
 begin
  repeat
   if Debug then ShowSECD; 
   { DumpStack; }
   inc(LoopCnt);
   if userMode then inc(CPCnt);

   { Test if timelimit is reached }
   if (CPCnt>ShdMaxCnt) and userMode
    then Intr(1) 
    else if Regs[c].t=null 
     then Rtn
     else begin
      Car(c,w1);
      if Regs[w1].t<>int 
       then RTError(7,'Command not found at the top of C') 
       else begin
        cmd:=Regs[w1].v shr 24;
        par:=Regs[w1].v and $ffffff;
        SwapOK:=false;
        Phase0;
        if not SwapOK then Phase1;
       end;
     end;

  until stopSEC;
  Just(0);
 end;

procedure secd_start;
 begin
  writeln('Loading kernel.sec  ...');
  ReadSFrom('kernel.sec',c);
  SetAtom(s,null,0); 
  ShowStat;
  writeln('Executing kernel ...');
  if ParamCount>0 
   then Debug:=ParamStr(1)='debug'
   else Debug:=false; 
  secd_loop;
  ShowStat;
  ShowSECD; 
  close(stderr);
 end;
 
begin
 LoopCnt:=0;
 CPCnt:=0;
end.


