unit secd_str;
interface

var 
 fin,fout:text;
 AtomPtr: longint;

function GetStr(v:longint):string;
function GetLong(v:longint):string;
procedure NewAtom(s:string; reg:byte);

procedure ReadSFrom(fname:string; r:byte);
procedure WriteSTo (fname:string; r:byte);

implementation

uses secd_mem;

type
 TAtomS=string[32];
const 
 SpecChar=['(',')','.',' '];
 MaxStr = 500;
var
 Atoms: array[0..MaxStr] of TAtomS;
 
function GetStr(v:longint):string;
 begin GetStr:=Atoms[v] end;

const
 MnemMax=40;
 SECDmnem:array[1..MnemMax] of TAtomS=
 ('ld-2',
  'ldc',
  'ldf',
  'none',
  'rtn-b',
  'dum',
  'dec',
  'int',
  'inc',
  'car',
  'cdr',
  'atom',
  'cons',
  'eq',
  'none',
  'none',
  'none',
  'none',
  'none',
  'none',
  'stop',
  'add',
  'sub',
  'mul',
  'div',
  'rem',
  'leq',
  'none',
  'none',
  'none',
  'none',
  'let-b',
  'trlet-b',
  'letrec-b',
  'trletr-b',
  'app-b',
  'trapp-b',
  'sel-b',
  'trsel-b',
  'none'
 ); 
 MnemBase=$FFFFFF;

function MnemHead(i:byte):string;
 var c1:string;
 begin
  c1:=SECDmnem[i];
  if pos('-',c1)>0 then c1:=copy(c1,1,pos('-',c1)-1);
  MnemHead:=c1;
 end
 ; 
function MnemTail(i:byte):string;
 var c1:string;
 begin
  c1:=SECDmnem[i];
  if pos('-',c1)>0 then delete(c1,1,pos('-',c1)) else c1:='';
  MnemTail:=c1;
 end; 

function GetLong(v:longint):string;
 var s,s1,mt:string; n:longint;
 begin
  if v>MnemBase then begin
   n:=v shr 24;
   if n>MnemMax then Error('Big SECD code');
   s:='#'+MnemHead(n);
   mt:=MnemTail(n);
   if mt<>'' then case mt[1] of
    'b':begin
         n:=v and MnemBase;
         Str(n,s1);
         s:=s+'_'+s1;
        end; 
    '2':begin
         n:=(v and MnemBase) shr 8;
         Str(n,s1);
         s:=s+'_'+s1;
         n:=(v and MnemBase) and $ff;
         Str(n,s1);
         s:=s+'_'+s1;
        end;
   end;      
  end else Str(v,s);
  GetLong:=s;
 end;
 
procedure NewAtom(s:string; reg:byte);
 var n,i:longint; w1,w2:string;
 procedure CreateInt;
  var i,j:longint;
  begin
   if w1='none' then Error('undefined SECD code');
   j:=0;
   for i:=1 to MnemMax do if w1=MnemHead(i) then j:=i; 
   if j=0 then Error('Bad mnemonick');
   n:=j shl 24;
   if w2<>'' then if pos('_',w2)>0 then begin
    w1:=copy(w2,1,pos('_',w2)-1);
    delete(w2,1,pos('_',w2));
    val(w1,j,i);
    if i<>0 then Error('Bad first parameter for LD command');
    n:=n+256*j;
    val(w2,j,i);
    if i<>0 then Error('Bad second parameter for LD command');
    n:=n+j;
   end else begin
    val(w2,j,i);
    if i<>0 then Error('Bad parameter for SECD code');
    n:=n+j;
   end;
   SetAtom(reg,int,n);
  end;
 begin
  if (s='NIL') or (s='nil') 
   then SetAtom(reg,null,0)
   else begin
    val(s,n,i);
    if i=0
     then SetAtom(reg,int,n)
     else if s[1]='#' then begin
      if pos('_',s)>0 then begin
       w1:=copy(s,2,pos('_',s)-2);
       w2:=s; delete(w2,1,pos('_',s));
      end else begin
       w1:=s; delete(w1,1,1);
       w2:='';
      end;
      CreateInt;
     end else begin
      n:=AtomPtr-1;
      while (n>=0) and (Atoms[n]<>s) do dec(n);
      if n<0 then begin
       n:=AtomPtr; inc(AtomPtr);
       if AtomPtr>MaxStr then Error('Atom space overflow');
       Atoms[n]:=s;
      end;
      SetAtom(reg,atom,n);
     end;
   end;
 end;
 
var 
 w:char;

function GetLex:string;
 var s:string; 
 procedure rd;
  begin
   if eof(fin) then w:=')' else read(fin,w); 
   if (w=chr(10)) or (w=chr(13)) then w:=' ';
  end;
 begin
  while w=' ' do rd; s:=w;
  if w in SpecChar
   then rd
   else while not (w in SpecChar) do begin
    rd; if not (w in SpecChar) then s:=s+w;
   end;
  GetLex:=s;  
 end;

procedure ReadSExp(r0,r1:byte);
 var s:string;
 procedure ReadTail; forward; 
 procedure ReadSExp0;
  begin
   s:=GetLex;
   if s='(' then ReadTail else NewAtom(s,r0)
  end;
 procedure ReadTail; 
  procedure Tail0;
   begin
    Push(r0,r1); ReadTail; Roll(r1,r0);
   end;
  begin
   s:=GetLex;
   if s='('
    then begin ReadTail; Tail0 end
    else if s=')'
     then SetAtom(r0,null,0) 
     else if s='.' 
      then begin 
       ReadSExp0; s:=GetLex;
       if s<>')' then Error('Bad S-Expresion');
      end 
      else begin NewAtom(s,r0); Tail0 end;
  end;
 begin
  ReadSExp0;
  w:=' ';
 end;

procedure ReadSFrom(fname:string; r:byte);
 begin
  assign(fin,fname); reset(fin);
  ReadSExp(r,MaxReg); close(fin);
 end;
 
procedure WriteSTo(fname:string; r:byte);
 begin
  close(fout);
  assign(fout,fname);rewrite(fout);
  ShowReg(r,99999,true); writeln(fout);
  close(fout);
  assign(fout,'');rewrite(fout);
 end;
 
begin
 assign(fout,'');rewrite(fout);
 w:=' ';
 AtomPtr:=0;
end.


