unit secd_cod;
interface

const
 s=0; e=1; c=2; d=3;
 w1=4; w2=5;

 Debug:boolean=false;

var
 LoopCnt:longint;

procedure secd_loop;
procedure ShowSECD;

{ 
 SECD commands:

  1 LD
  2 LDC
  3 LDF
  4 
  5 RTN n
    (x x1 x2 ... xn s) e c (e1 c1 d) --> (x s) e1 c1 d
  6 DUM
  7 DEC
  8 INT
  9 INC
 10 CAR
 11 CDR
 12 ATOM
 13 CONS
 14 EQ
 15 APP   
    (c'.e' s) e c d --> s s.e' c' (e c d)
 16 TR_APP
    (c'.e' s) e c d --> s s.e' c' d
 17 RAP   
    (c'.e' s) nil.e c d --> s SetCar(e',s) c' (e c d)
 18 TR_RAP
    (c'.e' s) nil.e c d --> s SetCar(e',s) c' d
 19 SEL
 20 TR_SEL
 21 STOP

}

implementation
uses secd_mem, secd_str;

procedure ShowSECD;
 begin
  writeln(fout,'SECD: Loops=',LoopCnt,'  Cons=',NodePtr); 
  write(fout,'S= '); ShowReg(s,100,false); writeln(fout);
  write(fout,'E= '); ShowReg(e,100,false); writeln(fout);
  write(fout,'C= '); ShowReg(c,100,false); writeln(fout);
  write(fout,'D= '); ShowReg(d,100,false); writeln(fout);
  {readln;} 
 end;

procedure secd_loop;
 var
  cmd:word;
 procedure AppCmd(noRec:boolean);
  begin
   if (cmd and 1)=1 then begin
    Push(c,d);
    if noRec
     then Push(e,d)
     else begin Cdr(e,w1); Push(w1,d) end;
   end;  
   Pop(s,e);
   Pop(e,c);
   if noRec
    then Push(s,e) 
    else SetCar(e,s);
{  SetAtom(s,null,0); }
  end;
 procedure SelCmd;
  var s1:string; OK:boolean;
  begin
   Pop(s,w1);
   if Regs[w1].t<>atom then Error('If exp is not boolean (T/F)');
   s1:=GetStr(Regs[w1].v);
   OK:=(s1='T') or (s1='t');
   if (cmd and 1)=1 then begin 
    if OK
     then begin Pop(c,w1); Pop(c,w2) end 
     else begin Pop(c,w2); Pop(c,w1) end;
    Push(c,d); Push(e,d);
    MoveReg(w1,c);
   end else if OK then CarSelf(c) else begin CdrSelf(c); CarSelf(c) end;
  end;
 procedure LoadValue;
  begin
   Pop(c,w1); Pop(w1,w2);
   if Regs[w1].t<>int then Error('Bad LD second argument'); 
   if Regs[w2].t<>int then Error('Bad LD furst argument');
   GetNth(e, w2,Regs[w2].v);
   GetNth(w2,w1,Regs[w1].v);
   Push(w1,s);
  end;
 procedure UniCmd;
  begin
   Pop(s,w1); 
   case cmd of
    10:CarSelf(w1);
    11:CdrSelf(w1);
    12:if Regs[w1].t=atom then NewAtom('T',w1) else NewAtom('F',w1);
    8:if Regs[w1].t=int  then NewAtom('T',w1) else NewAtom('F',w1);
   end;     
   Push(w1,s);
  end;
 procedure BinCmd;
  begin
   Pop(s,w1); Pop(s,w2);
   case cmd of
    13:PushR(w2,w1);
    14:if (Regs[w2].t=Regs[w1].t) and (Regs[w2].v=Regs[w1].v) 
        then NewAtom('T',w1) else NewAtom('F',w1);
   end;     
   Push(w1,s);
  end;
 procedure UniIntCmd;
  begin
   Pop(s,w1);
   if Regs[w1].t<>int 
    then Error('The argument must be int'); 
   case cmd of
    7:dec(Regs[w1].v);
    9:inc(Regs[w1].v);
   end;
   Push(w1,s);
  end; 
 procedure BinIntCmd;
  begin
   Pop(s,w1);
   Pop(s,w2);
   if Regs[w1].t<>int 
    then Error('Second argument must be int'); 
   if Regs[w2].t<>int 
    then Error('Furst argument must be int'); 
   case cmd of
     0:; { Dummy }
{
    15:Regs[w1].v:=Regs[w2].v+Regs[w1].v;
    16:Regs[w1].v:=Regs[w2].v-Regs[w1].v;
    17:Regs[w1].v:=Regs[w2].v*Regs[w1].v;
    18:Regs[w1].v:=Regs[w2].v div Regs[w1].v;
    19:Regs[w1].v:=Regs[w2].v mod Regs[w1].v;
    20:if Regs[w2].v <= Regs[w1].v
        then NewAtom('T',w1) else NewAtom('F',w1);
}        
   end;
   Push(w1,s);
  end;
 procedure RtnDrop;
  var i:word;
  begin
   Pop(c,w1);
   if Regs[w1].t<>int 
    then Error('The argument of RTN/DROP must be int')
    else i:=Regs[w1].v; 
   if cmd=5 then begin Pop(d,e); Pop(d,c) end;
   if i>0 then begin
    Pop(s,w1);
    while i>0 do begin CdrSelf(s); dec(i) end;
    Push(w1,s);
   end;
  end;
 begin
  repeat
   if Debug then ShowSECD; 
   inc(LoopCnt);
   Pop(c,w1);
   if Regs[w1].t<>int 
    then Error('Command not found at the top of C') 
    else begin
     cmd:=Regs[w1].v;
     if cmd=21 then Push(w1,c);
     case cmd of
      1:LoadValue;
      2:Roll(c,s);
      3:begin Pop(c,w1); PushR(e,w1); Push(w1,s) end;
      4,5:RtnDrop;
      6:begin SetAtom(w1,null,-1); Push(w1,e) end;
      7:UniIntCmd;
      8:UniCmd;
      9:UniIntCmd;
      10..12:UniCmd;
      13..14:BinCmd;
      15,16:AppCmd(true);
      17,18:AppCmd(false);
      19,20:SelCmd;

      29    :BinIntCmd; { Not used in this release }
     end;
    end;
  until cmd=21;
 end;

begin
 LoopCnt:=0;
end.


