unit secd_msg;

interface

uses secd_mem;

procedure SendMsg;
procedure RecvMsg;
procedure ProcLoad;
procedure ProcSave;
procedure IncPend;

{

 Pipe is passive - (q0.q1) or waiting - [pipe: s' (e'.c')]
 
 SEND
 (Pipe   msg s) e c --> ?
 (Stream msg s) e c --> ?

 RECV
 (Pipe   s) e c --> ?
 (Stream s) e c --> ?

}

implementation

uses secd_cod, secd_str;

procedure ProcLoad;
 begin
  if Regs[r1].t=null then while Regs[r0].t=node do Roll(r0,r1);
  if Regs[r1].t=node then begin
   Pop(r1,c);
   Pop(c,s);
   Pop(c,e);
   ChCnt:=0;
  end;
  if debug then begin
   writeln(stderr,'------------- New Proc --------------');
   ShowSECD;
  end; 
  dec(PendingCnt); 
  CPCnt:=0;
 end;

procedure IncPend;
 begin
  inc(PendingCnt);
  if PendingCnt>PendMax then PendMax:=PendingCnt;
 end;
 
procedure ProcSave;
 begin
  Push(e,c);
  Push(s,c);
  Push(c,r0); 
  IncPend;
 end;

procedure SendMsg;
 var ws:string;
 begin
  Just(1);
  case SubTag(a) of
   cons,pipe:
    ProcSave; { Delay current process: r0 --> (((msg s) e c) r0) }
  end;  
  ChCnt:=0;
  Pop(s,b); { a=Pipe/Stream, b:=msg } 
  case SubTag(a) of
   cons:begin
      Car(a,w1);
      Push(b,w1);
      SetCar(a,w1);
      ProcLoad;
     end;
   pipe:begin
      Car(a,s);
      Cdr(a,c); Pop(c,e);
      SetAtom(w1,null,0);
      SetCar(a,w1); SetCdr(a,w1);
      SetSubTag(a,cons);
      CPCnt:=0;
      MoveReg(b,a);
      ChCnt:=1;
     end;
   stream:begin
      Car(a,w1);
      case Regs[b].t of
       null:ws:='nil';
       int:ws:=GetLong(Regs[b].v);
       atom:ws:=GetStr(Regs[b].v);
       node:Error('Sending node to stream is impossible');
      end; 
      FPutStr(PStream(Regs[w1].v),ws);
      MoveReg(b,a);
      ChCnt:=1;
     end;  
  end; 
 end;

procedure RecvMsg;
 begin
  Just(1);
  ChCnt:=0;
  case SubTag(a) of
   cons:begin
      Car(a,b); Cdr(a,w1);
      if Regs[w1].t=null then while Regs[b].t=node do Roll(b,w1);
      if Regs[w1].t=null then begin
       Push(e,c);
       SetCar(a,s); SetCdr(a,c);
       SetSubTag(a,pipe);
       ProcLoad;
      end else begin
       SetCar(a,b); 
       Pop(w1,b);
       SetCdr(a,w1);
       MoveReg(b,a);
       ChCnt:=1;
      end;
     end;
   pipe:Error('Somebody wait on this pipe');
   stream:begin
      Car(a,w1);
      NewAtom(FGetLex(PStream(Regs[w1].v)),a);
      ChCnt:=1;
     end;
  end; 
 end;

end.

