unit secd_str;
interface

var 
 fin,fout:text;
 AtomPtr: longint;

function GetStr(v:longint):string;
procedure NewAtom(s:string; reg:byte);

procedure ReadSFrom(fname:string; r:byte);
procedure WriteSTo (fname:string; r:byte);

implementation

uses secd_mem;

const 
 SpecChar=['(',')','.',' '];
 MaxStr = 1000;
var
 Atoms: array[0..MaxStr] of string;
 
function GetStr(v:longint):string;
 begin GetStr:=Atoms[v] end;
 
procedure NewAtom(s:string; reg:byte);
 var n,i:longint;
 begin
  if (s='NIL') or (s='nil') 
   then SetAtom(reg,null,0)
   else begin
    val(s,n,i);
    if i=0
     then SetAtom(reg,int,n)
     else begin
      n:=AtomPtr-1;
      while (n>=0) and (Atoms[n]<>s) do dec(n);
      if n<0 then begin
       n:=AtomPtr; inc(AtomPtr);
       if AtomPtr>MaxStr then Error('Atom space overflow');
       Atoms[n]:=s;
      end;
      SetAtom(reg,atom,n);
     end;
   end;
 end;
 
var 
 w:char;

function GetLex:string;
 var s:string; 
 procedure rd;
  begin
   if eof(fin) then w:=')' else read(fin,w); 
   if (w=chr(10)) or (w=chr(13)) then w:=' ';
  end;
 begin
  while w=' ' do rd; s:=w;
  if w in SpecChar
   then rd
   else while not (w in SpecChar) do begin
    rd; if not (w in SpecChar) then s:=s+w;
   end;
  GetLex:=s;  
 end;

procedure ReadSExp(r0,r1:byte);
 var s:string;
 procedure ReadTail; forward; 
 procedure ReadSExp0;
  begin
   s:=GetLex;
   if s='(' then ReadTail else NewAtom(s,r0)
  end;
 procedure ReadTail; 
  procedure Tail0;
   begin
    Push(r0,r1); ReadTail; Roll(r1,r0);
   end;
  begin
   s:=GetLex;
   if s='('
    then begin ReadTail; Tail0 end
    else if s=')'
     then SetAtom(r0,null,0) 
     else if s='.' 
      then begin 
       ReadSExp0; s:=GetLex;
       if s<>')' then Error('Bad S-Expresion');
      end 
      else begin NewAtom(s,r0); Tail0 end;
  end;
 begin
  ReadSExp0;
  w:=' ';
 end;

procedure ReadSFrom(fname:string; r:byte);
 begin
  assign(fin,fname); reset(fin);
  ReadSExp(r,MaxReg); close(fin);
 end;
 
procedure WriteSTo(fname:string; r:byte);
 begin
  close(fout);
  assign(fout,fname);rewrite(fout);
  ShowReg(r,99999,true); writeln(fout);
  close(fout);
  assign(fout,'');rewrite(fout);
 end;
 
begin
 assign(fout,'');rewrite(fout);
 w:=' ';
 AtomPtr:=0;
end.


