unit secd_cod;
interface

const
 s=0; e=1; c=2; w1=4; a=5;

 Debug:boolean=false;

var
 LoopCnt:longint;

procedure secd_loop;
procedure ShowSECD;

{ 
 SECD commands:

  1 LD x y       s  e c           --> ((GetNth(GetNth(e,x),y) s) e c  
  2 LDC          s  e (x c)       --> (x s)   e      c 
  3 LDF          s  e (f c)       --> (x.e s) e      c 
  4 
  5 RTN          (x e' c' s) e c  --> (x s)   e'     c'
  6 DUM          s           e c  --> s      (nil e) c 

  
  7 DEC     (x s) e c  --> (x-1 s)      e c    
  8 INT     (x s) e c  --> (int?(x) s)  e c
  9 INC     (x s) e c  --> (x+1 s)      e c 
 10 CAR     (x s) e c  --> (car(x) s)   e c
 11 CDR     (x s) e c  --> (cdr(x) s)   e c
 12 ATOM    (x s) e c  --> (atom?(x) s) e c
 13 CONS    (x y s) e c  --> (cons(x,y) s) e c  
 14 EQ      (x y s) e c  --> (eq(x,y)   s) e c
 15    
 16 
 17    
 18
 19 
 20 
 21 STOP
 22 ADD     (x y s) e c  --> (x+y s)       e c 
 23 SUB     (x y s) e c  --> (x-y s)       e c 
 24 MUL     (x y s) e c  --> (x*y s)       e c 
 25 DIV     (x y s) e c  --> ((x div y) s) e c 
 26 REM     (x y s) e c  --> ((x mod y) s) e c 
 27 LEQ     (x y s) e c  --> ((x <= y) s)  e c 
 28
 29
 20
 31

 ---------------------------- APP / TR_APP codes: ---------------------------------

 32 LET n        s         e     (c' c)    --> (e c Drop(s,n))       (s e)       c' 
 33 TRLET n      s         e     c         --> Drop(s,n)             (s e)       c  
 34 LETREC n     s         e     (c' c)    --> ((cdr e) c Drop(s,n)) Setcar(e,s) c' 
 35 TRLETR n     s         e     c         --> Drop(s,n)             Setcar(e,s) c  
 36 APP n        (c'.e' s) e     c         --> (e c Drop(s,n))       (s e')      c' 
 37 TR_APP n     (c'.e' s) e     c         --> Drop(s,n)             (s e')      c' 
 38 SEL          (x s)     e     (c1 c2 c) --> (e c s)               e           cx 
 39 TR_SEL       (x s)     e     (c1 c2)   --> s                     e           cx 

}

implementation
uses secd_mem, secd_str;

const
 CacheON:boolean=false;

procedure ShowSECD;
 const CMax=100;
 procedure ShowCache;
  begin
   if CacheON then begin
    write(fout,'Sh= '); ShowReg(a,CMax,false); writeln(fout);
    write(fout,'St= '); 
   end else write(fout,'S=  '); 
   ShowReg(s,CMax,false); writeln(fout);
  end;
 begin
  writeln(fout,'SECD: Loops=',LoopCnt,'  Cons=',ConsCnt); 
  ShowCache;
  write(fout,'E=  '); ShowReg(e,CMax,false); writeln(fout);
  write(fout,'C=  '); ShowReg(c,CMax,false); writeln(fout);
  {readln;} 
 end;

procedure secd_loop;
 var
  cmd:word;
  par:longint;
  OK:boolean;
 procedure LoadA;
  begin if not CacheON then begin Pop(s,a);  CacheON:=true  end end;
 procedure SaveA; 
  begin if CacheON then begin Push(a,s); CacheON:=false end end;
 procedure Test;
  var s1:string;  
  begin
   LoadA; CacheON:=false;
   if Regs[a].t<>atom then Error('If exp is not boolean (T/F)');
   s1:=GetStr(Regs[a].v);
   OK:=(s1='T') or (s1='t');
  end; 
 procedure UniCmd;
  begin
   LoadA;
   if cmd in [7,9] then if Regs[a].t<>int 
    then Error('The argument must be int'); 
   case cmd of
     7:dec(Regs[a].v);
     8:if  Regs[a].t=int  then NewAtom('T',a) else NewAtom('F',a);
     9:inc(Regs[a].v);
    10:CarSelf(a);
    11:CdrSelf(a);
    12:if  Regs[a].t=atom then NewAtom('T',a) else NewAtom('F',a);
   end;     
  end;
 procedure BinCmd;
  begin
   LoadA;
   Pop(s,w1);
   if cmd in [22..27] then begin
    if  Regs[a].t<>int then Error('Second argument must be int'); 
    if Regs[w1].t<>int then Error( 'Furst argument must be int'); 
   end;
   case cmd of
    13:PushR(w1,a);
    14:if (Regs[w1].t=Regs[a].t) and (Regs[w1].v=Regs[a].v) 
        then NewAtom('T',a) else NewAtom('F',a);
    22:Regs[a].v:=Regs[w1].v+Regs[a].v;
    23:Regs[a].v:=Regs[w1].v-Regs[a].v;
    24:Regs[a].v:=Regs[w1].v*Regs[a].v;
    25:Regs[a].v:=Regs[w1].v div Regs[a].v;
    26:Regs[a].v:=Regs[w1].v mod Regs[a].v;
    27:if Regs[w1].v <= Regs[a].v
        then NewAtom('T',a) else NewAtom('F',a);
   end;     
  end;
 procedure Rtn;
  begin
   LoadA;
   Pop(s,e); 
   Pop(s,c);
  end;
 procedure LDx;
  begin
   if CacheON then Push(a,s) else CacheON:=true;
   case cmd of
    1:begin
       GetNth(e,w1,par shr 8);
       GetNth(w1,a,par and $ff);
      end;
    2:Pop(c,a);
    3:begin Pop(c,a); PushR(e,a) end;
   end;
  end; 
 begin
  repeat
   if Debug then ShowSECD; 
   inc(LoopCnt);
   Pop(c,w1);
   if Regs[w1].t<>int 
    then Error('Command not found at the top of C') 
    else begin
     cmd:=Regs[w1].v shr 24;
     par:=Regs[w1].v and $ffffff;
     case cmd of
       1..3:LDx;
       4:;
       5:Rtn;
       6:begin SetAtom(w1,null,-1); Push(w1,e) end;
       7..12:UniCmd;
      13..14:BinCmd;
      15..20:;
      21:push(w1,c);  
      22..27:BinCmd;
      32:begin { LET:     s e (c' c)  --> (e c Drop(s,n)) (s e) c'  }
          SaveA; Cdr(c,w1);
          MoveReg(e,a); Push(s,e);
          Drop(s,par);
          Push(w1,s); CarSelf(c);
          CacheON:=true;
         end;
      33:begin { TRLET:   s e c       --> Drop(s,n) (s e) c       }
          SaveA; 
          Push(s,e); Drop(s,par);
         end;
      34:begin { LETREC:  s e (c' c)  --> ((cdr e) c Drop(s,n)) Setcar(e,s) c' }
          SaveA; Cdr(c,w1);
          Cdr(e,a); SetCar(e,s);
          Drop(s,par);
          Push(w1,s); CarSelf(c);
          CacheON:=true;
         end;
      35:begin { TRLETR:  s e c       --> Drop(s,n) Setcar(e,s) c  } 
          SaveA; 
          SetCar(e,s); Drop(s,par);
         end;
      36:begin { APP:     (c'.e' s) e c --> (e c Drop(s,n)) (s e') c' }
          LoadA;
          MoveReg(a,w1);
          MoveReg(e,a);
          Cdr(w1,e); Push(s,e);
          Drop(s,par);
          Push(c,s); Car(w1,c);
         end; 
      37:begin { TRAPP:   (c'.e' s) e c --> Drop(s,n) (s e')    c' }
          LoadA; CacheON:=false;
          MoveReg(a,e); Pop(e,c);
          Push(s,e); Drop(s,par);
         end; 
      38:begin { SEL:     (x s) e (c1 c2 c) --> (e c s) e cx }
          Test;
          if OK
           then begin Pop(c,a); CdrSelf(c) end 
           else begin CdrSelf(c); Pop(c,a) end;
          Push(c,s); 
          MoveReg(a,c);
          MoveReg(e,a);
          CacheON:=true;
         end;
      39:begin { TRSEL:   (x s) e (c1 c2)   --> s e cx }
          Test;
          if OK then CarSelf(c) else CdrSelf(c);
         end;
     end;
    end;
  until cmd=21;
  SaveA;
 end;

begin
 LoopCnt:=0;
end.


