unit secd_cod;
interface

const
 s=0; e=1; c=2; d=3;
 w1=4; w2=5;

var
 LoopCnt:longint;

procedure secd_loop;

{ 
 SECD commands:

  1 LD
  2 LDC
  3 LDF
  4 
  5 RTN
  6 DUM
  7 DEC
  8 INT
  9 INC
 10 CAR
 11 CDR
 12 ATOM
 13 CONS
 14 EQ
 15 APP
 16 TR_APP
 17 RAP 
 18 TR_RAP
 19 SEL
 20 TR_SEL
 21 STOP

}

implementation
uses secd_mem, secd_str;

procedure ShowSECD;
 begin
  writeln('SECD: Loops=',LoopCnt,'  Cons=',NodePtr); 
  write('S= '); ShowReg(s,120,false); writeln;
  write('E= '); ShowReg(e,120,false); writeln;
  write('C= '); ShowReg(c,120,false); writeln;
  write('D= '); ShowReg(d,120,false); writeln;
  readln; 
 end;

procedure secd_loop;
 var
  cmd:word;
 procedure AppCmd(noRec:boolean);
  begin
   if (cmd and 1)=1 then begin
    cons(c,d,d);
    if noRec
     then cons(e,d,d)
     else begin cdr(e,w1); cons(w1,d,d) end;
   end;  
   Pop(s,e);
   Pop(e,c);
   if noRec
    then Roll(s,e) 
    else begin Pop(s,w1); SetCar(e,w1) end;
{
   cons(s,d,d); 
   SetAtom(s,null,0);
}   
  end;
 procedure SelCmd;
  var s1:string; OK:boolean;
  begin
   Pop(s,w1);
   if Regs[w1].t<>atom then Error('If exp is not boolean (T/F)');
   s1:=GetStr(Regs[w1].v);
   OK:=(s1='T') or (s1='t');
   if (cmd and 1)=1 then begin 
    if OK
     then begin Pop(c,w1); Pop(c,w2) end 
     else begin Pop(c,w2); Pop(c,w1) end;
    cons(c,d,d); cons(e,d,d);
    MoveReg(w1,c);
   end else if OK then car(c,c) else begin cdr(c,c); car(c,c) end;
  end;
 procedure LoadValue;
  var level:word;
  begin
   Pop(c,w1); Pop(w1,w2);
   if Regs[w1].t<>int then Error('Bad LD second argument'); 
   if Regs[w2].t<>int then Error('Bad LD furst argument');
   level:=Regs[w2].v; 
   MoveReg(e,w2);
   while level>0 do begin cdr(w2,w2); dec(level) end;
   car(w2,w2);
   level:=Regs[w1].v;
   while level>0 do begin cdr(w2,w2); dec(level) end;
   car(w2,w1);
   cons(w1,s,s);
  end;
 procedure UniCmd;
  begin
   Pop(s,w1); 
   case cmd of
    10:car(w1,w1);
    11:cdr(w1,w1);
    12:if Regs[w1].t=atom then NewAtom('T',w1) else NewAtom('F',w1);
    8:if Regs[w1].t=int  then NewAtom('T',w1) else NewAtom('F',w1);
   end;     
   cons(w1,s,s);
  end;
 procedure BinCmd;
  begin
   Pop(s,w1); Pop(s,w2);
   case cmd of
    13:cons(w1,w2,w1);
    14:if (Regs[w2].t=Regs[w1].t) and (Regs[w2].v=Regs[w1].v) 
        then NewAtom('T',w1) else NewAtom('F',w1);
   end;     
   cons(w1,s,s);
  end;
 procedure UniIntCmd;
  begin
   Pop(s,w1);
   if Regs[w1].t<>int 
    then Error('The argument must be int'); 
   case cmd of
    7:dec(Regs[w1].v);
    9:inc(Regs[w1].v);
   end;
   cons(w1,s,s);
  end; 
 procedure BinIntCmd;
  begin
   Pop(s,w1);
   Pop(s,w2);
   if Regs[w1].t<>int 
    then Error('Second argument must be int'); 
   if Regs[w2].t<>int 
    then Error('Furst argument must be int'); 
   case cmd of
     0:; { Dummy }
{
    15:Regs[w1].v:=Regs[w2].v+Regs[w1].v;
    16:Regs[w1].v:=Regs[w2].v-Regs[w1].v;
    17:Regs[w1].v:=Regs[w2].v*Regs[w1].v;
    18:Regs[w1].v:=Regs[w2].v div Regs[w1].v;
    19:Regs[w1].v:=Regs[w2].v mod Regs[w1].v;
    20:if Regs[w2].v <= Regs[w1].v
        then NewAtom('T',w1) else NewAtom('F',w1);
}        
   end;
   cons(w1,s,s);
  end;
 begin
  repeat
   { ShowSECD; }
   inc(LoopCnt);
   Pop(c,w1);
   if Regs[w1].t<>int 
    then Error('Command not found at the top of C') 
    else begin
     cmd:=Regs[w1].v;
     if cmd=21 then cons(w1,c,c);
     case cmd of
      1:LoadValue;
      2:Roll(c,s);
      3:begin Pop(c,w1); cons(w1,e,w1); cons(w1,s,s) end;
      4:;
      5:begin Pop(d,e); Pop(d,c) end;
      6:begin SetAtom(w1,null,-1); cons(w1,e,e) end;
      7:UniIntCmd;
      8:UniCmd;
      9:UniIntCmd;
      10..12:UniCmd;
      13..14:BinCmd;
      15,16:AppCmd(true);
      17,18:AppCmd(false);
      19,20:SelCmd;

      29    :BinIntCmd; { Not used in this release }
     end;
    end;
  until cmd=21;
 end;

begin
 LoopCnt:=0;
end.


