#!/bin/sh

V0=0
V1=8
V=$V0.$V1
lisp=Base_4

./make_hist.sh > History.txt
./make_clean.sh

n=`ls SECD_$V.??.tar.gz| cut -f3 -d.`

if [ $n ]
then
 echo "Removing version $V."$n
 rm *_$V.??.tar.gz
 let n=$n+1
 echo "Creating version $V."$n

 tar czf SECD_$V.${n}.tar.gz *
 tar czf BASE_$V.${n}.tar.gz \
   History.txt Inherit.lst \
   Mini_0 Base_0 Base_1 Base_2 Base_3 Base_4
 tar czf LISP_$V.${n}.tar.gz \
   History.txt Inherit.lst \
   $lisp

 rm ../../sec_pkg/*.tar.gz
 cp SECD_$V.*.tar.gz ../../sec_pkg/SECD_$V.tar.gz
 cp BASE_$V.*.tar.gz ../../sec_pkg/BASE_$V.tar.gz
 cp LISP_$V.*.tar.gz ../../sec_pkg/LISP_$V.tar.gz

 cp History.txt  ../../sec_pkg
 cp Inherit.lst  ../../sec_pkg
 cp $lisp/html/*.html ../../sec_pkg
else
 echo "Old version of the SECD package not found !"
fi

echo "Done ..."
