unit secd_cod;
interface

const
 s=0; e=1; c=2; d=3;
 w1=4; a=5;

 Debug:boolean=false;

var
 LoopCnt:longint;

procedure secd_loop;
procedure ShowSECD;

{

 SECD commands:

  1 LD x y
    s e c d             --> ((GetNth(GetNth(e,x),y) s) e c d 
  2 LDC
    s e (x c) d         --> (x s)   e c d
  3 IF
    (x s) e (c1 c2 c) d --> (ci s)  e c d
  4 LAMBDA
    (x s) e c d         --> (x.e s) e c d
  5 RTN n
    (x s) e c (e1 c1 d) --> (x Drop(s,n)) e1 c1 d
  6 DUM
    s e c d             --> s (nil e) c d
  7 DEC
  8 INT
  9 INC
 10 CAR
 11 CDR
 12 ATOM
 13 CONS
 14 EQ
 21 STOP

 22 ADD 
    (x y s) e c d --> (x+y s)       e c d
 23 SUB
    (x y s) e c d --> (x-y s)       e c d
 24 MUL
    (x y s) e c d --> (x*y s)       e c d
 25 DIV 
    (x y s) e c d --> ((x div y) s) e c d
 26 REM
    (x y s) e c d --> ((x mod y) s) e c d
 27 LEQ
    (x y s) e c d --> ((x <= y) s)  e c d

 --- Apply / TR_apply forms: ---
 
 32 APP   
    (c'.e' s) e c d    --> s         (s e')      c' (e c d)
 33 TRAPP n
    (c'.e' s) e c d    --> Drop(s,n) (s e')      c' d
 34 APPi   
    (c' s)    e c d    --> s         (s e)       c' (e c d)
 35 TRAPPi n
    (c' s)    e c d    --> Drop(s,n) (s e)       c' d
 36 RAPi   
    (c' s)    e c d    --> s         SetCar(e,s) c' ((cdr e) c d)
 37 TRRAPi n
    (c' s)    e c d    --> Drop(s,n) SetCar(e,s) c' d
 38 APP0   
    (c' s)    e c d    --> s         e           c' (e c d)
 39 TRAPP0 n
    (c' s)    e c d    --> Drop(s,n) e           c' d
 
}

implementation
uses secd_mem, secd_str;

const
 CacheON:boolean=false;

procedure ShowSECD;
 const CMax=100;
 procedure ShowCache;
  begin
   if CacheON then begin
    write(fout,'Sh= '); ShowReg(a,CMax,false); writeln(fout);
    write(fout,'St= '); 
   end else write(fout,'S=  '); 
   ShowReg(s,CMax,false); writeln(fout);
  end;
 begin
  writeln(fout,'SECD: Loops=',LoopCnt,'  Cons=',ConsCnt); 
  ShowCache;
  write(fout,'E=  '); ShowReg(e,CMax,false); writeln(fout);
  write(fout,'C=  '); ShowReg(c,CMax,false); writeln(fout);
  write(fout,'D=  '); ShowReg(d,CMax,false); writeln(fout);
  {readln;} 
 end;

procedure secd_loop;
 var
  cmd:word;
  par:longint;
 procedure LoadA;
  begin if not CacheON then begin Pop(s,a);  CacheON:=true  end end;
 procedure AppCmdNew;
  var v:byte;
  begin
   v:=(cmd and 6) shr 1;
   if (cmd and 1)=0 then begin
    Push(c,d);
    if v<>2
     then Push(e,d)
     else begin Cdr(e,w1); Push(w1,d) end;
   end;
   if CacheON then CacheON:=false else Pop(s,a);
   case v of
    0:begin Car(a,c); Cdr(a,e) end;
    1..3:MoveReg(a,c);
   end; 
   case v of
    0,1:Push(s,e);
    2:SetCar(e,s);
   end; 
   if (cmd and 1)=1 then Drop(s,par);
  end;
 procedure Sel0;
  var s1:string; OK:boolean; 
  begin
   LoadA; 
   if Regs[a].t<>atom then Error('If exp is not boolean (T/F)');
   s1:=GetStr(Regs[a].v);
   OK:=(s1='T') or (s1='t');
   if OK 
    then begin Pop(c,a); CdrSelf(c) end 
    else begin CdrSelf(c); Pop(c,a) end;
  end;
 procedure UniCmd;
  begin
   LoadA;
   if cmd in [7,9] then if Regs[a].t<>int 
    then Error('The argument must be int'); 
   case cmd of
     7:dec(Regs[a].v);
     8:if  Regs[a].t=int  then NewAtom('T',a) else NewAtom('F',a);
     9:inc(Regs[a].v);
    10:CarSelf(a);
    11:CdrSelf(a);
    12:if  Regs[a].t=atom then NewAtom('T',a) else NewAtom('F',a);
   end;     
  end;
 procedure BinCmd;
  begin
   LoadA;
   Pop(s,w1);
   if cmd in [22..27] then begin
    if  Regs[a].t<>int then Error('Second argument must be int'); 
    if Regs[w1].t<>int then Error( 'Furst argument must be int'); 
   end;
   case cmd of
    13:PushR(w1,a);
    14:if (Regs[w1].t=Regs[a].t) and (Regs[w1].v=Regs[a].v) 
        then NewAtom('T',a) else NewAtom('F',a);
    22:Regs[a].v:=Regs[w1].v+Regs[a].v;
    23:Regs[a].v:=Regs[w1].v-Regs[a].v;
    24:Regs[a].v:=Regs[w1].v*Regs[a].v;
    25:Regs[a].v:=Regs[w1].v div Regs[a].v;
    26:Regs[a].v:=Regs[w1].v mod Regs[a].v;
    27:if Regs[w1].v <= Regs[a].v
        then NewAtom('T',a) else NewAtom('F',a);
   end;     
  end;
 procedure Rtn;
  begin
   Pop(d,e); 
   Pop(d,c);
   if par>0 then begin
    LoadA;
    Drop(s,par);
   end;
  end;
 procedure LDx;
  begin
   if CacheON then Push(a,s) else CacheON:=true;
   case cmd of
    1:begin
       GetNth(e,w1,par shr 8);
       GetNth(w1,a,par and $ff);
      end;
    2:Pop(c,a);
   end;
  end; 
 begin
  repeat
   if Debug then ShowSECD; 
   inc(LoopCnt);
   Pop(c,w1);
   if Regs[w1].t<>int 
    then Error('Command not found at the top of C') 
    else begin
     cmd:=Regs[w1].v shr 24;
     par:=Regs[w1].v and $ffffff;
     case cmd of
       1..2:LDx;
       3:Sel0;
       4:begin LoadA; PushR(e,a) end; 
       5:Rtn;
       6:begin SetAtom(w1,null,-1); Push(w1,e) end;
       7..12:UniCmd;
      13..14:BinCmd;
      15..20:;
      21:push(w1,c);  
      22..27:BinCmd;
      32..39:AppCmdNew;
     end;
    end;
  until cmd=21;
  if CacheON then begin Push(a,s); CacheON:=false end;
 end;

begin
 LoopCnt:=0;
end.


